/*   UltimateIRCd - Ultimate Internet Relay Chat Daemon, src/s_ultimate.c
**
**   Written for UltimateIRCd by ShadowRealm Creations.
**   Copyright (C) 1997-2000 Infomedia Inc.
**
**   Some functions in this file is Copyright
**   (C) 1999 Carsten Munk (Techie/Stskeeps) <stskeeps@tspre.org>
**
**   This program is free software; you can redistribute it and/or modify
**   it under the terms of the GNU General Public License as published by
**   the Free Software Foundation; either version 1, or (at your option)
**   any later version.
**
**   This program is distributed in the hope that it will be useful,
**   but WITHOUT ANY WARRANTY; without even the implied warranty of
**   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**   GNU General Public License for more details.
**
**   You should have received a copy of the GNU General Public License
**   along with this program; if not, write to the Free Software
**   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

/*
**
** June 9th  2000
** Big cleanup. Moved all the different notices over to s_serv.c where they belong.
** Lost track of everything. More tidy now at least - HAMLET
**
*/

/*
**
** November 18th 1999
** Added m_settings() and moved all the addline's to s_addline.c - HAMLET
**
*/

/*
**
** November 8th 1999.
** Adding m_sethost(), m_setident(), m_setname(), m_chghost() and m_chgident() from unreal. - HAMLET
**
*/

/*
**
** September 17th 1999.
** Adding m_sdesc() and m_tsctl() from unreal. - HAMLET
**
*/

/*
**
** I really need to start getting this mess cleaned up.
** Most of this stuff shouldnt be in here at all.
** Adding some of Stskeeps Unreal code. Rawk the world.
** 23 August - HAMLET
**
*/

#include <stdlib.h>
#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include <unistd.h>
#include <sys/socket.h>
#include <sys/file.h>
#include <sys/ioctl.h>
#include <sys/un.h>
#include "true.h"
#include "struct.h"
#include "common.h"
#include "sys.h"
#include "numeric.h"
#include "msg.h"
#include "channel.h"
#include "userload.h"
#include <sys/stat.h>
#include <fcntl.h>
#include <utmp.h>
#include "h.h"


#define AllocCpy(x,y) x = (char *) MyMalloc(strlen(y) + 1); strcpy(x,y)
#define IRCD_RESTRICT "ircd.channels"

aCRline *crlines = NULL;

char   *cannotjoin_msg = NULL;

time_t TSoffset = 0;


char strlower(char *buf)
{
    int     i = 0;

    while (buf[i] != '\0')
    {
	buf[i] = tolower(buf[i]);
	i++;
    }
    buf[i] = '\0';
}




/* stricmp, strnicmp:  Case-insensitive versions of strcmp() and
 *                     strncmp().
 */
/*
int
stricmp (const char *s1, const char *s2)
{
    register int c;

    while ((c = tolower (*s1)) == tolower (*s2))
    {
        if (c == 0)
            return 0;
        s1++;
        s2++;
    }
    if (c < tolower (*s2))
        return -1;
    return 1;
}

int
strnicmp (const char *s1, const char *s2, size_t len)
{
    register int c;

    if (!len)
        return 0;
    while ((c = tolower (*s1)) == tolower (*s2) && len > 0)
    {
        if (c == 0 || --len == 0)
            return 0;
        s1++;
        s2++;
    }
    if (c < tolower (*s2))
        return -1;
    return 1;
}

*/



/* restrict channel stuff */

 
int	channel_canjoin(sptr,name)
aClient *sptr;
char *name;
{
	aCRline *p;
	
	if (IsOper(sptr))
		return 1;
	if (IsULine(sptr,sptr))
		return 1;	
	if (!crlines)
		return 1;
	for (p = crlines; p; p = p->next)
	{
		if (!match(p->channel, name))
			return 1;
	}
	return 0;
}

int	cr_add(channel, type)
char *channel;
int  type;
{
	aCRline *fl;
	
	fl = (aCRline *) MyMalloc(sizeof(aCRline));
	
	AllocCpy(fl->channel, channel);
	fl->type = type;
	fl->next = crlines;
	fl->prev = NULL;
	if (crlines)
		crlines->prev = fl;
	crlines = fl;
}

aCRline     *cr_del(fl)
aCRline *fl;
{
	aCRline *p, *q;
        for (p = crlines; p; p = p->next) {
                if (p == fl)
                {
                        q = p->next;
                        MyFree((char *) p->channel);
                        /* chain1 to chain3 */
                        if (p->prev) {
                                p->prev->next = p->next;
                        }
                          else
                        {
                                crlines = p->next;
                        }
                        if (p->next) {
                                p->next->prev = p->prev;
                        }
                        MyFree((aCRline *) p);
                        return q;
                }
        }
        return NULL;
}

/* 
   chrestrict.conf
   ------------
allow #cafe
allow #teens
*/
int	cr_loadconf(void)
{
	char	buf[2048];
	char	*x,*y;
	FILE	*f;	
	
	f = fopen(IRCD_RESTRICT, "r");
	if (!f)
		return -1;	
		
	while (fgets(buf, 2048,f))
	{
		if (buf[0] == '#' || buf[0] == '/' || buf[0] == '\0')
			continue;
		iCstrip(buf);
		x = strtok(buf, " ");
		if (strcmp("allow", x)==0)
		{
			y = strtok(NULL, " ");
			if (!y)
				continue;
			cr_add(y,0);
		}
		else
		if (strcmp("msg", x)==0)
		{
			y = strtok(NULL, "");
			if (!y)
				continue;
			if (cannotjoin_msg)
				MyFree((char *) cannotjoin_msg);
			cannotjoin_msg = MyMalloc(strlen(y) + 1);
			strcpy(cannotjoin_msg, y);
		}

	}
	return 0; 
}

void   cr_rehash(void)
{
	aCRline *p,q;
	
	for (p = crlines; p; p = p->next)
	{
		if ((p->type == 0) || (p->type == 2))
		{
	                 q.next = cr_del(p);
	           	 p = &q;
		}
	}
	cr_loadconf();
}

void	cr_report(sptr)
aClient *sptr;
{
	aCRline *tmp;
	char	*filemask, *reason;
	char	a;
		
	if (!crlines)
	{
			sendto_one(sptr, ":%s %d %s :There are currently no channel restrictions in place on %s",
      				me.name, RPL_SETTINGS, sptr->name, me.name);	
			sendto_one(sptr, rpl_str(RPL_ENDOFSETTINGS), me.name, sptr->name);
			return;
	}

			sendto_one(sptr, ":%s %d %s :\2~~~~~~~~ Allowed Channels ~~~~~~~~\2",
	 	 		me.name, RPL_SETTINGS, sptr->name);

			sendto_one(sptr, ":%s %d %s :",
      				me.name, RPL_SETTINGS, sptr->name);


	for (tmp = crlines; tmp; tmp = tmp->next)
	{
		filemask = BadPtr(tmp->channel) ? "<NULL>" : tmp->channel;
/*
		if (tmp->type == 0)
			a = 'c';
		if (tmp->type == 1)
			a = 's';
		if (tmp->type == 2)
			a = 'o';
*/


			sendto_one(sptr, ":%s %d %s :%s",
      				me.name, RPL_SETTINGS, sptr->name, filemask);	


//		sendto_one(sptr, ":%s %i %s :%s", me.name, RPL_TEXT, sptr->name, filemask);
//		sendto_one(sptr, ":%s %i %s :%c %s", me.name, RPL_TEXT, sptr->name, a, filemask);
//		sendto_one(sptr, ":%s NOTICE %s :*** (allow) [%c] %s", me.name, sptr->name, a, filemask);
	}
			sendto_one(sptr, ":%s %d %s :",
      				me.name, RPL_SETTINGS, sptr->name);

			sendto_one(sptr, ":%s %d %s :\2~~~~~~~~~~~~~~~~~~~~~~~~~~\2",
      				me.name, RPL_SETTINGS, sptr->name);	

			sendto_one(sptr, rpl_str(RPL_ENDOFSETTINGS), me.name, sptr->name);

}




/*
 * m_isoper
 */
int	m_isoper(cptr, sptr, parc, parv)
aClient *cptr, *sptr;
int	parc;
char	*parv[];
{
        Reg1    aClient *acptr;
	char	*name;
 
  if (check_registered (sptr))
    return 0;

        if (parc < 2)
		{
	   sendto_one(sptr, err_str(ERR_NEEDMOREPARAMS),
                           me.name, parv[0], "ISOPER");
                return 0;
	  	}
         if (!(acptr = find_person(parv[1], NULL)))
		{
	 sendto_one(sptr, "NOTICE %s :Cant find anyone with that nick.",
                        sptr->name);
                return 0;
		}

	if (hunt_server(cptr,sptr,":%s ISOPER :%s",1,parc,parv) == HUNTED_ISME)
		{
			if (IsLocOp(acptr))
			{
			sendto_one(sptr, rpl_str(RPL_ISLOCOP), me.name, parv[0], parv[1], acptr->user->server);
			}
			
			else if (IsOper(acptr))
			{
			sendto_one(sptr, rpl_str(RPL_ISOPER), me.name, parv[0], parv[1], acptr->user->server);
			}
			else if (!IsAnOper(acptr))
			{
			sendto_one(sptr, rpl_str(RPL_ISNOTOPER), me.name, parv[0], parv[1]);
			}

			sendto_one(sptr, rpl_str(RPL_ENDOFISOPER), me.name, parv[0]);
		}
        return 0;
}


/*
**
** m_tsctl - Stskeeps
** Adapted to UltimateIRCd by HAMLET
** Also use stricmp instead of strcmp.
** Now its not case sensitive anymore.
**      parv[0] = sender prefix
**      parv[1] = command
**      parv[2] = options
**
*/

int     m_tsctl(cptr, sptr, parc, parv)
aClient *cptr, *sptr;
int     parc;
char    *parv[];
{
	time_t	timediff;
	
	if (check_registered(sptr))
                 return 0;

	if (!MyClient(sptr)) 
		goto doit;

	if (!IsAdmin(sptr))
	{
                sendto_one(sptr, err_str(ERR_NOPRIVILEGES), me.name, parv[0]);
                return 0;
	}

	doit:
	if (parv[1])
	{
		if (*parv[1] == '\0')
		{
	                sendto_one(sptr, err_str(ERR_NEEDMOREPARAMS),
        	                   me.name, parv[0], "TSCTL");
			return 0;
		}

		if (stricmp(parv[1], "offset")==0) {
			if (!parv[3])
			{
				sendto_one(sptr, ":%s NOTICE %s :*** TSCTL OFFSET: /tsctl offset <+|-> <time>", me.name, sptr->name);
				return 0;
			}
			if (*parv[2] == '\0' || *parv[3] == '\0')
			{
				sendto_one(sptr, ":%s NOTICE %s :*** TSCTL OFFSET: /tsctl offset <+|-> <time>", me.name, sptr->name);
				return 0;
			}				
			if (!(*parv[2] == '+' || *parv[2] == '-'))
			{
				sendto_one(sptr, ":%s NOTICE %s :*** TSCTL OFFSET: /tsctl offset <+|-> <time>", me.name, sptr->name);
				return 0;

			}
			
			switch (*parv[2])
			{
				case '+' :
						timediff = atol(parv[3]);
						TSoffset = timediff;
						sendto_ops("TS Control - %s set TStime() to be diffed +%li", sptr->name, timediff);					
						sendto_serv_butone(&me, ":%s GLOBOPS :TS Control - %s set TStime to be diffed +%li", me.name, sptr->name, timediff);
						break;						
				case '-' :
						timediff = atol(parv[3]);
						TSoffset = -timediff;
						sendto_ops("TS Control - %s set TStime() to be diffed -%li", sptr->name, timediff);					
						sendto_serv_butone(&me, ":%s GLOBOPS :TS Control - %s set TStime to be diffed -%li", me.name, sptr->name, timediff);
						break;						
			}
			return 0;
		}
		if (stricmp(parv[1], "time")==0)
		{
			sendto_one(sptr, ":%s NOTICE %s :*** TStime=%li time()=%li TSoffset=%li", me.name,
				sptr->name, TStime(), time(NULL), TSoffset);
			return 0;
		}

		if (stricmp(parv[1], "alltime")==0)
		{
			sendto_one(sptr, ":%s NOTICE %s :*** Server=%s TStime=%li time()=%li TSoffset=%li", me.name,
				sptr->name, me.name, TStime(), time(NULL), TSoffset);
			sendto_serv_butone(cptr, ":%s TSCTL alltime", sptr->name);
			return 0;
			
		}
		if (stricmp(parv[1], "svstime")==0)
		{
			if (parc < 3 || *parv[3] == '\0')
			{
				return 0;
			}
			if (!IsULine(cptr, sptr))
			{
				return 0;
			}
			
			timediff = atol(parv[3]);
			timediff = timediff - time(NULL);
			TSoffset = timediff;
			sendto_ops("TS Control - U:line set time to be %li (timediff: %li)", atol(parv[3]), timediff);
			sendto_serv_butone(cptr, ":%s TSCTL svstime %li", sptr->name, atol(parv[3]));
			return 0;
		}		

	}	
}

/*
**
** m_sdesc - 15/05/1999 - Stskeeps
** Adapted to UltimateIRCd by HAMLET
**  :prefix SDESC
**  parv[0] - sender
**  parv[1] - description
**  D: Sets server info if you are Server Admin (ONLINE)
**
*/

int     m_sdesc(cptr, sptr, parc, parv)
aClient *cptr, *sptr;
int parc;
char *parv[];
{
	if (!IsAdmin(sptr))
	{
                sendto_one(sptr, err_str(ERR_NOPRIVILEGES), me.name, parv[0]);
                return 0;
	}

	if (parc < 2)
		return;
	if (strlen(parv[1]) < 1) {
		if (MyConnect(sptr)) {
			sendto_one(sptr, ":%s NOTICE %s :*** Nothing to change to (SDESC)", me.name, sptr->name);
		}		
	}
	if (strlen(parv[1]) > (REALLEN2 - 1)) {
		if (MyConnect(sptr)) {
			sendto_one(sptr, ":%s NOTICE %s :*** /SDESC Error: \"Server info\" may maximum be %i characters of length", me.name, sptr->name, REALLEN2);
		}
		return 0;
	}

	ircsprintf(sptr->srvptr->info, "%s", parv[1]);
	
    sendto_serv_butone(&me, ":%s SDESC :%s", parv[0], parv[1]);
	
	if (MyConnect(sptr))
        sendto_one(sptr, ":%s NOTICE %s :Your \"server description\" is now set to be %s - you have to set it manually to undo it", me.name, parv[0], parv[1]);      
	sendto_netinfo("from %s : \2%s\2 changed server description to: \2(%s)\2", me.name, parv[0], sptr->srvptr->info);
//	sendto_serv_butone(&me, ":%s NETINFO :\2%s\2 changed server description to: \2(%s)\2", me.name, parv[0], sptr->srvptr->info);
        return 0;

//	sendto_ops("Server description for %s is now '%s' changed by %s", sptr->srvptr->name, sptr->srvptr->info, parv[0]);
}

/*
   m_sethost() added by Stskeeps (30/04/1999)
               (modified at 15/05/1999) by Stskeeps | Potvin
   :prefix SETHOST newhost
   parv[0] - sender
   parv[1] - newhost
   D: this performs a mode +x function to set hostname
      to whatever you want to (if you are IRCop) **efg**
      Very experimental currently
   A: Remember to see server_etabl ;)))))
      *evil fucking grin*
*/
int     m_sethost(cptr, sptr, parc, parv)
aClient *cptr, *sptr;
int parc;
char *parv[];
{
	char	*vhost, *s;

	int	permit = 0; // 0 = opers(glob/locop) 1 = global oper 2 = not MY clients.. 
	int	donotice = 0; /* send out notices if local connect ( 0 = NOT 1 = yes ) */
	int	legalhost = 1; /* is legal characters? */

	if (check_registered(sptr))
        	return 0;

	if (!MyConnect(sptr))
		goto have_permit1;
     	switch (permit) {
		case 0: if (!IsAnOper(sptr)) {
					sendto_one(sptr, err_str(ERR_NOPRIVILEGES), me.name, parv[0]);
					return 0;
			}
			break;
		case 1: if (!IsOper(sptr)) {
				sendto_one(sptr, err_str(ERR_NOPRIVILEGES), me.name, parv[0]);
				return 0;
			}
			break;
		case 2: if (MyConnect(sptr)) {
				sendto_one(sptr, err_str(ERR_NOPRIVILEGES), me.name, parv[0]);
				return 0;
			}
		default:
			sendto_ops_butone(IsServer(cptr) ? cptr : NULL, sptr,
			       ":%s WALLOPS :[SETHOST] Somebody fixing this corrupted server? !(0|1) !!!", me.name); 
				break;				                                
	}

	have_permit1:	
	if (parc < 2)
		vhost = NULL;
	else
		vhost = parv[1];

	/* bad bad bad boys .. ;p */	
	if (vhost == NULL) {
		if (MyConnect(sptr)) {
			sendto_one(sptr, ":%s NOTICE %s :*** Syntax: /SetHost <new host>", me.name, parv[0]);		
		}
		return;
	}
	/* uh uh .. too small */
	if (strlen(parv[1]) < 1) {
		if (MyConnect(sptr))
			sendto_one(sptr, ":%s NOTICE %s :*** /SetHost Error: Atleast write SOMETHING that makes sense (':' string)",
				me.name, sptr->name);
	}
	/* too large huh? */
	if (strlen(parv[1]) > 63 ) {
		/* ignore us as well if we're not a child of 3k */
		if (MyConnect(sptr))
			sendto_one(sptr, ":%s NOTICE %s :*** /SetHost Error: Hostnames are limited to 63 characters.", me.name, sptr->name);
		return;
	}
	
	/* illegal?! */
	for (s = vhost; *s; s++) {
		if (!isallowed(*s)) {
			legalhost = 0;
		}
	}
	
	if (legalhost == 0) {
		sendto_one(sptr, ":%s NOTICE %s :*** /SetHost Error: A hostname may contain a-z, A-Z, 0-9, '-' & '.' - Please only use them", me.name, parv[0]);
		return 0;
	}

    /* hide it */
    if (!IsHidden(sptr)) {
	SetHidden(sptr);
//    sptr->umodes |= UMODE_HIDE;
	}
    /* get it in */
    ircsprintf(sptr->user->virthost, "%s", vhost);
    /* spread it out */
    sendto_serv_butone(cptr, ":%s SETHOST %s", sptr->name, parv[1]);
    
    if (MyConnect(sptr)) {
//    	sendto_one(sptr, ":%s MODE %s :+x", sptr->name, sptr->name);
    	sendto_one(sptr, ":%s NOTICE %s :Your nick!user@host-mask is now (%s!%s@%s) - To disable it type /mode %s -x", me.name, parv[0], 
                                  	parv[0], sptr->user->username, vhost, parv[0]);
    }
	return 0;
}


/* m_setident - 12/05/1999 - Stskeeps
 *  :prefix SETIDENT newident
 *  parv[0] - sender
 *  parv[1] - newident
 *  D: This will set your username to be <x> (like (/setident Root))
 *     (if you are IRCop) **efg*
 *     Very experimental currently
 * 	   Cloning of m_sethost at some points - so same authors ;P
*/

int     m_setident(cptr, sptr, parc, parv)
aClient *cptr, *sptr;
int parc;
char *parv[];
{

	char	*vident, *s;
	int		permit = 0; /* 0 = opers(glob/locop) 1 = global oper */
	int		donotice = 0; /* send out notices if local connect ( 0 = NOT 1 = yes )*/
	int		legalident = 1; /* is legal characters? */
    if (check_registered(sptr))
         return 0;
	if (!MyConnect(sptr))
		goto permit_2;
	switch (permit) {
		case 0: if (!IsAnOper(sptr)) {
					sendto_one(sptr, err_str(ERR_NOPRIVILEGES), me.name, parv[0]);
					return 0;
				}
				break;
		case 1: if (!IsOper(sptr)) {
					sendto_one(sptr, err_str(ERR_NOPRIVILEGES), me.name, parv[0]);
					return 0;
				}
				break;
		case 2: if (MyConnect(sptr)) {
					sendto_one(sptr, err_str(ERR_NOPRIVILEGES), me.name, parv[0]);
					return 0;					
				}
				break;
		default:
				sendto_ops_butone(IsServer(cptr) ? cptr : NULL, sptr,
				       ":%s WALLOPS :[SETIDENT] Somebody fixing this corrupted server? !(0|1) !!!", me.name); 
				break;				                                
	}
	permit_2:	
	if (parc < 2)
		vident = NULL;
	else
		vident = parv[1];

	/* bad bad bad boys .. ;p */	
	if (vident == NULL) {
		if (MyConnect(sptr)) {
			sendto_one(sptr, ":%s NOTICE %s :*** Syntax: /SetIdent <new host>", me.name, parv[0]);		
		}
		return;
	}
	if (strlen(parv[1]) < 1) {
		if (MyConnect(sptr))
			sendto_one(sptr, ":%s NOTICE %s :*** /SetIdent Error: Atleast write SOMETHING that makes sense (':' string)",
				me.name, sptr->name);
	}

	/* too large huh? */
	if (strlen(vident) > ( USERLEN - 1)) {
		/* ignore us as well if we're not a child of 3k */
		if (MyConnect(sptr))
			sendto_one(sptr, ":%s NOTICE %s :*** /SetIdent Error: Usernames are limited to %i characters.", me.name, sptr->name, USERLEN);
		return;
	}
	
	/* illegal?! */
	for (s = vident; *s; s++) {
		if (!isallowed(*s)) {
			legalident = 0;
		}
		if (*s == '~')
			legalident = 1;	

	}
	
	if (legalident == 0) {
		sendto_one(sptr, ":%s NOTICE %s :*** /SetIdent Error: A username may contain a-z, A-Z, 0-9, '-', '~' & '.' - Please only use them", me.name, parv[0]);
		return 0;
	}
   
    /* get it in */
    ircsprintf(sptr->user->username, "%s", vident);
    /* spread it out */
    sendto_serv_butone(cptr, ":%s SETIDENT %s", sptr->name, parv[1]);
    
    if (MyConnect(sptr)) {
    	sendto_one(sptr, ":%s NOTICE %s :Your nick!user@host-mask is now (%s!%s@%s) - To disable ident set change it manually by /setident'ing again", me.name, parv[0], 
                                  	parv[0], sptr->user->username, 
                                  	IsHidden(sptr) ? sptr->user->virthost : sptr->user->host);
	}
    return;
}


/* m_setname - 12/05/1999 - Stskeeps
 *  :prefix SETNAME :gecos
 *  parv[0] - sender
 *  parv[1] - gecos
 *  D: This will set your gecos to be <x> (like (/setname :The lonely wanderer))
   yes it is experimental but anyways ;P
    FREEDOM TO THE USERS! ;)
*/

int     m_setname(cptr, sptr, parc, parv)
aClient *cptr, *sptr;
int parc;
char *parv[];
{
	if (parc < 2)
		return;
	if (strlen(parv[1]) > (REALLEN - 2)) {
		if (MyConnect(sptr)) {
			sendto_one(sptr, ":%s NOTICE %s :*** /SetName Error: \"Real names\" may maximum be %i characters of length", me.name, sptr->name, REALLEN);
		}
		return 0;
	}
	
	if (strlen(parv[1]) < 1) {
		sendto_one(sptr, ":%s NOTICE %s :Couldn't change realname - Nothing in parameter",
			me.name, sptr->name);
		return 0;
	}
		else 
			ircsprintf(sptr->info, "%s", parv[1]);
	

    sendto_serv_butone(&me, ":%s SETNAME :%s", parv[0], parv[1]);
	if (MyConnect(sptr))
       		 sendto_one(sptr, ":%s NOTICE %s :Your \"real name\" is now set to be %s - you have to set it manually to undo it", me.name, parv[0], parv[1]);      
          return 0;
 
//	sendto_serv_butone(cptr, ":%s SETNAME %s", parv[0], parv[1]);
	return 0;
}


/* 
 * m_chghost - 12/07/1999 (two months after I made SETIDENT) - Stskeeps
 * :prefix CHGHOST <nick> <new hostname>
 * parv[0] - sender
 * parv[1] - nickname
 * parv[2] - hostname
 *
*/

int     m_chghost(cptr, sptr, parc, parv)
aClient *cptr, *sptr;
int parc;
char *parv[];
{
	aClient	*acptr;
	char	*s;
	int		legalhost = 1;

    if (check_registered(sptr))
         return 0;

         
	if (MyClient(sptr))
		if (!IsAnOper(sptr))
		{
				sendto_one(sptr, err_str(ERR_NOPRIVILEGES), me.name, parv[0]);
			return 0;

		}

				
	if (parc < 3) {
		sendto_one(sptr, ":%s NOTICE %s :*** /ChgHost syntax is /ChgHost <nick> <newhost>", me.name, sptr->name);
		return 0;
	}
	
	if (strlen(parv[2]) < 1) {
		sendto_one(sptr, ":%s NOTICE %s :*** Write atleast something to change the host to!", me.name, sptr->name);
		return 0;
	}
	
	if (strlen(parv[2]) > 62) {
		sendto_one(sptr, ":%s NOTICE %s :*** ChgHost Error: Hostnames are limited to 63 characters.", me.name, sptr->name);
		return 0;
	}

	/* illegal?! */
	for (s = parv[2]; *s; s++) {
		if (!isallowed(*s)) {
			legalhost = 0;
		}
	}
	
	if (legalhost == 0) {
		sendto_one(sptr, ":%s NOTICE %s :*** /ChgHost Error: A hostname may contain a-z, A-Z, 0-9, '-' & '.' - Please only use them", me.name, parv[0]);
		return 0;
	}

	if ((acptr = find_person(parv[1], NULL))) {
		if (!IsULine(cptr, sptr)) {
			sendto_umode(UMODE_NGLOBAL, "%s changed the virtual hostname of %s (%s@%s) to be %s",
						sptr->name, acptr->name, acptr->user->username,
						(acptr->umodes & UMODE_HIDE ? acptr->user->virthost : acptr->user->realhost),
						parv[2]);
		}
		acptr->umodes |= UMODE_HIDE;		  		
		sendto_serv_butone(cptr, ":%s CHGHOST %s %s",
  					sptr->name,
  					acptr->name,
  					parv[2]);
  		ircsprintf(acptr->user->virthost, "%s", parv[2]);
		return 0;
	}
	 else
	{
		sendto_one(sptr, err_str(ERR_NOSUCHNICK), me.name, sptr->name, parv[1]);
		return 0;
	}
	return 0;
}

/* 
 * m_chgident - 12/07/1999 (two months after I made SETIDENT) - Stskeeps
 * :prefix CHGHOST <nick> <new identname>
 * parv[0] - sender
 * parv[1] - nickname
 * parv[2] - identname
 *
*/

int     m_chgident(cptr, sptr, parc, parv)
aClient *cptr, *sptr;
int parc;
char *parv[];
{
	aClient	*acptr;
	char	*s;
	int		legalident = 1;

    if (check_registered(sptr))
         return 0;

         
	if (MyClient(sptr))
		if (!IsAnOper(sptr))
		{
				sendto_one(sptr, err_str(ERR_NOPRIVILEGES), me.name, parv[0]);
			return 0;

		}

				
	if (parc < 3) {
		sendto_one(sptr, ":%s NOTICE %s :*** /ChgIdent syntax is /ChgIdent <nick> <newident>", me.name, sptr->name);
		return 0;
	}
	
	if (strlen(parv[2]) < 1) {
		sendto_one(sptr, ":%s NOTICE %s :*** Write atleast something to change the ident to!", me.name, sptr->name);
		return 0;
	}
	
	if (strlen(parv[2]) > (HOSTLEN - 1)) {
		sendto_one(sptr, ":%s NOTICE %s :*** ChgIdent Error: Too long ident!!", me.name, sptr->name);
		return 0;
	}

	/* illegal?! */
	for (s = parv[2]; *s; s++) {
		if (!isallowed(*s)) {
			legalident = 0;
		}
	}
	
	if (legalident == 0) {
		sendto_one(sptr, ":%s NOTICE %s :*** /ChgIdent Error: A ident may contain a-z, A-Z, 0-9, '-' & '.' - Please only use them", me.name, parv[0]);
		return 0;
	}

	if ((acptr = find_person(parv[1], NULL))) {
		if (!IsULine(cptr, sptr)) {
			sendto_umode(UMODE_NGLOBAL, "%s changed the virtual ident for %s. Old: %s  New: %s",
						sptr->name, acptr->name, acptr->user->username,	parv[2]);
		}
		sendto_serv_butone(cptr, ":%s CHGIDENT %s %s",
  					sptr->name,
  					acptr->name,
  					parv[2]);
  		ircsprintf(acptr->user->username, "%s", parv[2]);
		return 0;
	}
	 else
	{
		sendto_one(sptr, err_str(ERR_NOSUCHNICK), me.name, sptr->name, parv[1]);
		return 0;
	}
	return 0;
}


/*
**
** m_settings November 18th 1999 - HAMLET
**   Will display the dynconf settings for local or remote server.
**   /SETTINGS <optional servername>
**
*/
int	m_settings(cptr, sptr, parc, parv)
aClient *cptr, *sptr;
int	parc;
char	*parv[];
{

	if (MyClient(sptr) && !IsAnOper(sptr))
	{	
		if (parc < 2)
		{

		sendto_one(sptr, ":%s %d %s :\2~~~~~~~~ UltimateIRCd Settings ~~~~~~~~\2",
	 		me.name, RPL_SETTINGS, sptr->name);

		sendto_one(sptr, ":%s %d %s :",
      			me.name, RPL_SETTINGS, sptr->name);	


			sendto_one(sptr, ":%s %d %s :Use \2/SETTINGS (COMMAND)",
      				me.name, RPL_SETTINGS, sptr->name);	

			sendto_one(sptr, ":%s %d %s :",
      				me.name, RPL_SETTINGS, sptr->name);	


			sendto_one(sptr, ":%s %d %s :\2CHANNELS\2         View Allowed Channel Settings",
     				me.name, RPL_SETTINGS, sptr->name);	

		sendto_one(sptr, ":%s %d %s :",
      			me.name, RPL_SETTINGS, sptr->name);

		sendto_one(sptr, ":%s %d %s :\2~~~~~~~~~~~~~~~~~~~~~~~~~~\2",
      			me.name, RPL_SETTINGS, sptr->name);	

		sendto_one(sptr, rpl_str(RPL_ENDOFSETTINGS), me.name, sptr->name);


			return 0;
		}
		if (stricmp(parv[1], "channels")==0) {
			cr_report(sptr);
			return 0;
		}

		else
		{
		sendto_one(sptr, ":%s %d %s :Error: %s is not a supported parameter for SETTINGS.",
      			me.name, RPL_SETTINGS, sptr->name, parv[1]);
			sendto_one(sptr, rpl_str(RPL_ENDOFSETTINGS), me.name, sptr->name);
		return 0;
		}

	}
	if (hunt_server(cptr,sptr,":%s SETTINGS %s :%s",2,parc,parv)==HUNTED_ISME)
	{
		if (parc < 2)
		{

			sendto_one(sptr, ":%s %d %s :\2~~~~~~~~ UltimateIRCd Settings ~~~~~~~~\2",
	 	 		me.name, RPL_SETTINGS, sptr->name);

			sendto_one(sptr, ":%s %d %s :",
      				me.name, RPL_SETTINGS, sptr->name);	

			sendto_one(sptr, ":%s %d %s :Use \2/SETTINGS (COMMAND) [Server]",
      				me.name, RPL_SETTINGS, sptr->name);	

			sendto_one(sptr, ":%s %d %s :",
      				me.name, RPL_SETTINGS, sptr->name);	

			sendto_one(sptr, ":%s %d %s :\2DYNCONF\2          View IRCd Settings",
     				me.name, RPL_SETTINGS, sptr->name);	

			sendto_one(sptr, ":%s %d %s :\2NETINFO\2          View Network Info",
     				me.name, RPL_SETTINGS, sptr->name);

			sendto_one(sptr, ":%s %d %s :\2OPTIONS\2          View Network Options",
     				me.name, RPL_SETTINGS, sptr->name);

			sendto_one(sptr, ":%s %d %s :\2SERVICES\2         View Network Services Settings",
     				me.name, RPL_SETTINGS, sptr->name);

			sendto_one(sptr, ":%s %d %s :\2HOSTMASKS\2        View Network Hostmask Settings",
     				me.name, RPL_SETTINGS, sptr->name);

			sendto_one(sptr, ":%s %d %s :\2MISC\2             View Misc. Settings",
     				me.name, RPL_SETTINGS, sptr->name);

			sendto_one(sptr, ":%s %d %s :\2CHANNELS\2         View Allowed Channel Settings",
     				me.name, RPL_SETTINGS, sptr->name);	

			sendto_one(sptr, ":%s %d %s :",
      				me.name, RPL_SETTINGS, sptr->name);

			sendto_one(sptr, ":%s %d %s :\2~~~~~~~~~~~~~~~~~~~~~~~~~~\2",
      				me.name, RPL_SETTINGS, sptr->name);	

			sendto_one(sptr, rpl_str(RPL_ENDOFSETTINGS), me.name, sptr->name);


			return 0;
		}

		if (stricmp(parv[1], "dynconf")==0) {
			report_dynconf(sptr);
			return 0;
		}
		else if (stricmp(parv[1], "netinfo")==0) {
			report_network(sptr);
			return 0;
		}
		else if (stricmp(parv[1], "options")==0) {
			report_options(sptr);
			return 0;
		}
		else if (stricmp(parv[1], "hostmasks")==0) {
			report_hostmasks(sptr);
			return 0;
		}

		else if (stricmp(parv[1], "services")==0) {
			report_services(sptr);
			return 0;
		}

		else if (stricmp(parv[1], "misc")==0) {
			report_misc(sptr);
			return 0;
		}


		else if (stricmp(parv[1], "channels")==0) {
			cr_report(sptr);
			return 0;
		}
		
		else
		{
		sendto_one(sptr, ":%s %d %s :Error: %s is not a supported parameter for SETTINGS.",
      			me.name, RPL_SETTINGS, sptr->name, parv[1]);
			sendto_one(sptr, rpl_str(RPL_ENDOFSETTINGS), me.name, sptr->name);
		return 0;
		}
	
	}
	return 0;
}

/*
** m_ircops() By ScOrP|On
** Rewritten by HAMLET
**   Lists online IRCOps
**
*/

int m_ircops(cptr, sptr, parc, parv)
aClient *cptr, *sptr;
int     parc;
char    *parv[];
{
  aClient *acptr;
  char buf[BUFSIZE];
  int locals = 0, globals = 0;


	if (!MyClient(sptr))
	return 0;



  strcpy(buf, "============================================");
  sendto_one(sptr, rpl_str(RPL_IRCOPS), me.name, parv[0], buf);
  strcpy(buf, "\2Nick                           Status         Server\2");
  sendto_one(sptr, rpl_str(RPL_IRCOPS), me.name, parv[0], buf);
  strcpy(buf, "--------------------------------------------");
  sendto_one(sptr, rpl_str(RPL_IRCOPS), me.name, parv[0], buf);
  for (acptr = client; acptr; acptr = acptr->next)
  {
	  if (!(IsULine(cptr, acptr) || IsRBot(acptr) || IsSBot(acptr)) && IsAnOper(acptr))
        {
          if (!acptr->user) continue;
          ircsprintf(buf, "\2%-30s\2  %s  %-8s  %s", acptr->name ? acptr->name : "<Desconhecido>",
                                IsOper(acptr) ? "Global" : "Local", acptr->user->away ? "(AWAY)" : "", acptr->user->server);
          sendto_one(sptr, rpl_str(RPL_IRCOPS), me.name, parv[0], buf);
          sendto_one(sptr, rpl_str(RPL_IRCOPS), me.name, parv[0], "-");
          if (IsOper(acptr)) globals++;
          else locals++;
        }
   }
  ircsprintf(buf, "Total: \2%d\2 IRCOp%s connected - \2%d\2 Globa%s, \2%d\2 Loca%s", globals+locals,
                        (globals+locals) > 1 ? "s" : "",
                        globals, globals > 1 ? "ls" : "l", locals, locals > 1 ? "ls" : "l");
  sendto_one(sptr, rpl_str(RPL_IRCOPS), me.name, parv[0], buf);
  strcpy(buf, "============================================");
  sendto_one(sptr, rpl_str(RPL_IRCOPS), me.name, parv[0], buf);
  sendto_one(sptr, rpl_str(RPL_ENDOFIRCOPS), me.name, parv[0]);
  return 0;
}


/*
**
** m_uptime April 3rd 2000 - HAMLET
**   Will display the uptime of the server.
**
*/
int	m_uptime(cptr, sptr, parc, parv)
aClient *cptr, *sptr;
int	parc;
char	*parv[];
{

	if (hunt_server(cptr,sptr,":%s UPTIME :%s",1,parc,parv)==HUNTED_ISME)
	{
	int 	tmp_days, tmp_hours, tmp_minutes, tmp_seconds;
	char 	d[20], h[20], m[20], s[20];
	char	tmpstring[512];
	register time_t tmpnow;


	tmpnow = TStime() - me.since;

	tmp_days = tmpnow/86400;
	tmp_hours = (tmpnow/3600)%24;
	tmp_minutes = (tmpnow/60)%60;
	tmp_seconds = tmpnow%60;
	
	ircsprintf (d, "%d day%s, ", tmp_days, tmp_days>1 ? "s" : "");
	ircsprintf (h, "%d hour%s, ", tmp_hours, tmp_hours>1 ? "s" : "");
	ircsprintf (m, "%d minute%s, ", tmp_minutes, tmp_minutes>1 ? "s" : "");
	ircsprintf (s, "%d second%s ", tmp_seconds, tmp_seconds>1 ? "s" : "");

		strcpy	(tmpstring, "");

	if (tmp_days)
		strcat (tmpstring, d);
	if (tmp_hours)
		strcat (tmpstring, h);
	if (tmp_minutes)
		strcat (tmpstring, m);
	if (tmp_seconds)
		strcat (tmpstring, s);


		sendto_one(sptr, ":%s NOTICE %s :*** Uptime -- Server uptime %s", me.name, sptr->name, tmpstring);
	}
	return 0;
}


/*
**
** m_news - Lamego (Sun Mar 12 15:54:40 2000)
**      parv[0] = sender prefix 
**	parv[1] = TS
**      parv[2] = news bit mask
**	parv[3] = news message
**
*/
int
m_news(aClient *cptr, aClient *sptr, int parc, char *parv[]) 
{
    int newsmask= 0;

    if(!IsULine(cptr, sptr) || parc!=4)
    return 0;

    if (parv[2] && isdigit(*parv[2])) 
	newsmask = strtoul(parv[2], NULL, 0);

    if(!newsmask)
    return 0;

    sendto_news(sptr,newsmask,parv[3]);
    sendto_serv_butone(cptr, ":%s NEWS %s %s :%s",
		parv[0], parv[1], parv[2],parv[3]);
    return 0;
}

void getuptime()
{
	char	*tn = tmpnam(NULL),
			buf[128]; /* make sure it is large enough to hold uptime cmd PLUS the result from temp file */
	FILE	*fp;
	sprintf(buf, "uptime >%s", tn);
	system(buf);
	if(fp=fopen(tn, "r"))
	{
		fgets(buf, 128, fp);
		printf("uptime = %s\n", buf);
		fclose(fp);
		unlink(tn);
	}
}



